运行 [tekton.dev/v1]
- Description
- Run represents a single execution of a Custom Task.
- Type
object
Specification
.spec
- Description
- RunSpec defines the desired state of Run
- Type
object
.spec.params
- Description
- Params is a list of Param
- Type
array
.spec.params[]
- Description
- Param declares an ParamValues to use for the parameter called name.
- Type
object- Required
namevalue
.spec.podTemplate
- Description
- PodTemplate holds pod specific configuration
- Type
object
.spec.podTemplate.dnsConfig
- Description
- Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.
- Type
object
.spec.podTemplate.dnsConfig.nameservers
- Description
- A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.
- Type
array
.spec.podTemplate.dnsConfig.nameservers[]
- Type
string
.spec.podTemplate.dnsConfig.options
- Description
- A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.
- Type
array
.spec.podTemplate.dnsConfig.options[]
- Description
- PodDNSConfigOption defines DNS resolver options of a pod.
- Type
object
.spec.podTemplate.dnsConfig.searches
- Description
- A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.
- Type
array
.spec.podTemplate.dnsConfig.searches[]
- Type
string
.spec.podTemplate.env
- Description
- List of environment variables that can be provided to the containers belonging to the pod.
- Type
array
.spec.podTemplate.env[]
- Description
- EnvVar represents an environment variable present in a Container.
- Type
object- Required
name
.spec.podTemplate.env[].valueFrom
- Description
- Source for the environment variable's value. Cannot be used if value is not empty.
- Type
object
.spec.podTemplate.env[].valueFrom.configMapKeyRef
- Description
- Selects a key of a ConfigMap.
- Type
object- Required
key
.spec.podTemplate.env[].valueFrom.fieldRef
- Description
- Selects a field of the pod: supports metadata.name, metadata.namespace, `metadata.labels['<KEY>']`, `metadata.annotations['<KEY>']`, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP, status.podIPs.
- Type
object- Required
fieldPath
.spec.podTemplate.env[].valueFrom.resourceFieldRef
- Description
- Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported.
- Type
object- Required
resource
.spec.podTemplate.env[].valueFrom.secretKeyRef
- Description
- Selects a key of a secret in the pod's namespace
- Type
object- Required
key
.spec.podTemplate.hostAliases
- Description
- HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.
- Type
array
.spec.podTemplate.hostAliases[]
- Description
- HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.
- Type
object- Required
ip
.spec.podTemplate.hostAliases[].hostnames
- Description
- Hostnames for the above IP address.
- Type
array
.spec.podTemplate.hostAliases[].hostnames[]
- Type
string
.spec.podTemplate.imagePullSecrets
- Description
- ImagePullSecrets gives the name of the secret used by the pod to pull the image if specified
- Type
array
.spec.podTemplate.imagePullSecrets[]
- Description
- LocalObjectReference contains enough information to let you locate the referenced object inside the same namespace.
- Type
object
.spec.podTemplate.nodeSelector
- Description
- NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/
- Type
object
.spec.podTemplate.tolerations
- Description
- If specified, the pod's tolerations.
- Type
array
.spec.podTemplate.tolerations[]
- Description
- The pod this Toleration is attached to tolerates any taint that matches the triple <key,value,effect> using the matching operator <operator>.
- Type
object
.spec.podTemplate.topologySpreadConstraints
- Description
- TopologySpreadConstraints controls how Pods are spread across your cluster among failure-domains such as regions, zones, nodes, and other user-defined topology domains.
- Type
array
.spec.podTemplate.topologySpreadConstraints[]
- Description
- TopologySpreadConstraint specifies how to spread matching pods among the given topology.
- Type
object- Required
maxSkewtopologyKeywhenUnsatisfiable
.spec.podTemplate.topologySpreadConstraints[].labelSelector
- Description
- LabelSelector is used to find matching pods. Pods that match this label selector are counted to determine the number of pods in their corresponding topology domain.
- Type
object
.spec.podTemplate.topologySpreadConstraints[].labelSelector.matchExpressions
- Description
- matchExpressions is a list of label selector requirements. The requirements are ANDed.
- Type
array
.spec.podTemplate.topologySpreadConstraints[].labelSelector.matchExpressions[]
- Description
- A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
- Type
object- Required
keyoperator
.spec.podTemplate.topologySpreadConstraints[].labelSelector.matchExpressions[].values
- Description
- values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
- Type
array
.spec.podTemplate.topologySpreadConstraints[].labelSelector.matchExpressions[].values[]
- Type
string
.spec.podTemplate.topologySpreadConstraints[].labelSelector.matchLabels
- Description
- matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
- Type
object
.spec.podTemplate.topologySpreadConstraints[].matchLabelKeys
- Description
- MatchLabelKeys is a set of pod label keys to select the pods over which spreading will be calculated. The keys are used to lookup values from the incoming pod labels, those key-value labels are ANDed with labelSelector to select the group of existing pods over which spreading will be calculated for the incoming pod. The same key is forbidden to exist in both MatchLabelKeys and LabelSelector. MatchLabelKeys cannot be set when LabelSelector isn't set. Keys that don't exist in the incoming pod labels will be ignored. A null or empty list means only match against labelSelector. This is a beta field and requires the MatchLabelKeysInPodTopologySpread feature gate to be enabled (enabled by default).
- Type
array
.spec.podTemplate.topologySpreadConstraints[].matchLabelKeys[]
- Type
string
.spec.ref
- Description
- TaskRef can be used to refer to a specific instance of a task.
- Type
object
.spec.ref.params
- Description
- Params contains the parameters used to identify the referenced Tekton resource. Example entries might include "repo" or "path" but the set of params ultimately depends on the chosen resolver.
- Type
array
.spec.ref.params[]
- Description
- Param declares an ParamValues to use for the parameter called name.
- Type
object- Required
namevalue
.spec.spec
- Description
- Spec is a specification of a custom task
- Type
object
.spec.spec.spec
- Description
- Spec is a specification of a custom task
- Type
object
.spec.workspaces
- Description
- Workspaces is a list of WorkspaceBindings from volumes to workspaces.
- Type
array
.spec.workspaces[]
- Description
- WorkspaceBinding maps a Task's declared workspace to a Volume.
- Type
object- Required
name
.spec.workspaces[].configMap
- Description
- ConfigMap represents a configMap that should populate this workspace.
- Type
object
.spec.workspaces[].configMap.items
- Description
- items if unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.
- Type
array
.spec.workspaces[].configMap.items[]
- Description
- Maps a string key to a path within a volume.
- Type
object- Required
keypath
.spec.workspaces[].csi
- Description
- CSI (Container Storage Interface) represents ephemeral storage that is handled by certain external CSI drivers.
- Type
object- Required
driver
.spec.workspaces[].csi.nodePublishSecretRef
- Description
- nodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls. This field is optional, and may be empty if no secret is required. If the secret object contains more than one secret, all secret references are passed.
- Type
object
.spec.workspaces[].csi.volumeAttributes
- Description
- volumeAttributes stores driver-specific properties that are passed to the CSI driver. Consult your driver's documentation for supported values.
- Type
object
.spec.workspaces[].emptyDir
- Description
- EmptyDir represents a temporary directory that shares a Task's lifetime. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir Either this OR PersistentVolumeClaim can be used.
- Type
object
.spec.workspaces[].persistentVolumeClaim
- Description
- PersistentVolumeClaimVolumeSource represents a reference to a PersistentVolumeClaim in the same namespace. Either this OR EmptyDir can be used.
- Type
object- Required
claimName
.spec.workspaces[].projected
- Description
- Projected represents a projected volume that should populate this workspace.
- Type
object
.spec.workspaces[].projected.sources
- Description
- sources is the list of volume projections. Each entry in this list handles one source.
- Type
array
.spec.workspaces[].projected.sources[]
- Description
- Projection that may be projected along with other supported volume types. Exactly one of these fields must be set.
- Type
object
.spec.workspaces[].projected.sources[].clusterTrustBundle
- Description
- ClusterTrustBundle allows a pod to access the `.spec.trustBundle` field of ClusterTrustBundle objects in an auto-updating file. Alpha, gated by the ClusterTrustBundleProjection feature gate. ClusterTrustBundle objects can either be selected by name, or by the combination of signer name and a label selector. Kubelet performs aggressive normalization of the PEM contents written into the pod filesystem. Esoteric PEM features such as inter-block comments and block headers are stripped. Certificates are deduplicated. The ordering of certificates within the file is arbitrary, and Kubelet may change the order over time.
- Type
object- Required
path
.spec.workspaces[].projected.sources[].clusterTrustBundle.labelSelector
- Description
- Select all ClusterTrustBundles that match this label selector. Only has effect if signerName is set. Mutually-exclusive with name. If unset, interpreted as "match nothing". If set but empty, interpreted as "match everything".
- Type
object
.spec.workspaces[].projected.sources[].clusterTrustBundle.labelSelector.matchExpressions
- Description
- matchExpressions is a list of label selector requirements. The requirements are ANDed.
- Type
array
.spec.workspaces[].projected.sources[].clusterTrustBundle.labelSelector.matchExpressions[]
- Description
- A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
- Type
object- Required
keyoperator
.spec.workspaces[].projected.sources[].clusterTrustBundle.labelSelector.matchExpressions[].values
- Description
- values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
- Type
array
.spec.workspaces[].projected.sources[].clusterTrustBundle.labelSelector.matchExpressions[].values[]
- Type
string
.spec.workspaces[].projected.sources[].clusterTrustBundle.labelSelector.matchLabels
- Description
- matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
- Type
object
.spec.workspaces[].projected.sources[].configMap
- Description
- configMap information about the configMap data to project
- Type
object
.spec.workspaces[].projected.sources[].configMap.items
- Description
- items if unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.
- Type
array
.spec.workspaces[].projected.sources[].configMap.items[]
- Description
- Maps a string key to a path within a volume.
- Type
object- Required
keypath
.spec.workspaces[].projected.sources[].downwardAPI
- Description
- downwardAPI information about the downwardAPI data to project
- Type
object
.spec.workspaces[].projected.sources[].downwardAPI.items
- Description
- Items is a list of DownwardAPIVolume file
- Type
array
.spec.workspaces[].projected.sources[].downwardAPI.items[]
- Description
- DownwardAPIVolumeFile represents information to create the file containing the pod field
- Type
object- Required
path
.spec.workspaces[].projected.sources[].downwardAPI.items[].fieldRef
- Description
- Required: Selects a field of the pod: only annotations, labels, name, namespace and uid are supported.
- Type
object- Required
fieldPath
.spec.workspaces[].projected.sources[].downwardAPI.items[].resourceFieldRef
- Description
- Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported.
- Type
object- Required
resource
.spec.workspaces[].projected.sources[].secret
- Description
- secret information about the secret data to project
- Type
object
.spec.workspaces[].projected.sources[].secret.items
- Description
- items if unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.
- Type
array
.spec.workspaces[].projected.sources[].secret.items[]
- Description
- Maps a string key to a path within a volume.
- Type
object- Required
keypath
.spec.workspaces[].projected.sources[].serviceAccountToken
- Description
- serviceAccountToken is information about the serviceAccountToken data to project
- Type
object- Required
path
.spec.workspaces[].secret
- Description
- Secret represents a secret that should populate this workspace.
- Type
object
.spec.workspaces[].secret.items
- Description
- items If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.
- Type
array
.spec.workspaces[].secret.items[]
- Description
- Maps a string key to a path within a volume.
- Type
object- Required
keypath
.status
- Description
- RunStatus defines the observed state of Run
- Type
object
.status.annotations
- Description
- Annotations is additional Status fields for the Resource to save some additional State as well as convey more information to the user. This is roughly akin to Annotations on any k8s resource, just the reconciler conveying richer information outwards.
- Type
object
.status.conditions
- Description
- Conditions the latest available observations of a resource's current state.
- Type
array
.status.conditions[]
- Description
- Condition defines a readiness condition for a Knative resource. See: https://github.com/kubernetes/community/blob/master/contributors/devel/sig-architecture/api-conventions.md#typical-status-properties
- Type
object- Required
statustype
.status.extraFields
- Description
- ExtraFields holds arbitrary fields provided by the custom task controller.
- Type
object
.status.results
- Description
- Results reports any output result values to be consumed by later tasks in a pipeline.
- Type
array
.status.results[]
- Description
- RunResult used to describe the results of a task
- Type
object- Required
namevalue
.status.retriesStatus
- Description
- RetriesStatus contains the history of RunStatus, in case of a retry.
- Type
array
.status.retriesStatus[]
- Type
API Endpoints
The following API endpoints are available:
/apis/tekton.dev/v1alpha1/namespaces/{namespace}/runsDELETE: delete collection of RunGET: list objects of kind RunPOST: create a new Run
/apis/tekton.dev/v1alpha1/namespaces/{namespace}/runs/{name}DELETE: delete the specified RunGET: read the specified RunPATCH: partially update the specified RunPUT: replace the specified Run
/apis/tekton.dev/v1alpha1/namespaces/{namespace}/runs/{name}/statusGET: read status of the specified RunPATCH: partially update status of the specified RunPUT: replace status of the specified Run
/apis/tekton.dev/v1alpha1/namespaces/{namespace}/runs
- HTTP method
DELETE- Description
- delete collection of Run
- HTTP responses
- HTTP method
GET- Description
- list objects of kind Run
- HTTP responses
- HTTP method
POST- Description
- create a new Run
- Query parameters
- Body parameters
- HTTP responses
/apis/tekton.dev/v1alpha1/namespaces/{namespace}/runs/{name}
- HTTP method
DELETE- Description
- delete the specified Run
- Query parameters
- HTTP responses
- HTTP method
GET- Description
- read the specified Run
- HTTP responses
- HTTP method
PATCH- Description
- partially update the specified Run
- Query parameters
- HTTP responses
- HTTP method
PUT- Description
- replace the specified Run
- Query parameters
- Body parameters
- HTTP responses
/apis/tekton.dev/v1alpha1/namespaces/{namespace}/runs/{name}/status
- HTTP method
GET- Description
- read status of the specified Run
- HTTP responses
- HTTP method
PATCH- Description
- partially update status of the specified Run
- Query parameters
- HTTP responses
- HTTP method
PUT- Description
- replace status of the specified Run
- Query parameters
- Body parameters
- HTTP responses